//////////////////////////////////////////////////////////////////////////////
vw.chart = {

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//***
//*** draw pie chart
//***
/*
drawPieChart: function (control, xc, yc, r, prop, cPie, cColor, cLabel) {
//------------------------------
//control = ViewPro Control
//xc = Pie center x coordinate
//yc = Pie center y coordinate
//r = Pie radius
//cPie = Pie data collection
//cColor = Pie color collection
//cLabel = Pie label collection
//prop - properties
//------------------------------

//Working variables
var x1, y1, x2, y2, PieNum;
var a;         //Angleva
var da;        //Delta angle
var Sum, i;

        
    PieNum = cPie.length;

    //For normalizing pie
    Sum = 0;
    for (i = 0; i<PieNum; i++) {
        Sum = Sum + cPie[i];
    }
                  
    //Bounding rectangle
    var x = xc - r;
    var y = yc - r;
                
    //Fill attributes
    //control.FillStyle = 1
    //control.BackgroundMode = 1
    
    a = 0;
    var align;
    //Loop through each pie
    for (i = 0; i<PieNum; i++) {
        
        x1 = xc + r * Math.cos(a);
        y1 = yc - r * Math.sin(a);
        da = 2 * 3.14159 * cPie[i] / Sum;
        x2 = xc + r * Math.cos(a + da);
        y2 = yc - r * Math.sin(a + da);
        
        //Draw pie
        //control.ForeColor = cColor.Item[i];
        //control.FillColor = control.ForeColor;
        //control.drawPie (xc + r, yc + r, x1, y1, x2, y2);
            
        //Draw pie label
        //control.ForeColor = RGB(0, 0, 0);
        x2 = xc + r * Math.cos(a + da / 2);
        y2 = yc - r * Math.sin(a + da / 2);
        if (x2 > xc ) {
            //control.ObjectAlign = 0;
            align="left";
		}            
        else if (x2 = xc) {
            //control.ObjectAlign = 1;
            align="center";
		}            
        else {
            //control.ObjectAlign = 2;
            align="right";
        }
	    prop = vwstring.setKeyValue(prop, "align", align);
        control.drawString(x2, y2, cLabel[i], prop);
        
        a = a + da;
    }

},
*/

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//***
//***draw horizonatl bar graph
//***
drawHorzBarGraph: function (control, x, y, prop, tickSpaceX, tickSpaceY, cTickX, cTickY, cValue, cLabel) {
//------------------------------
//control - ontrol
//x = Graph Left
//y = Graph Top
//tickSpaceX = X tick mark space in twips
//tickSpaceY = Y tick mark space in twips
//cTickX = X tick mark text collection
//cTickY = Y tick mark text collection
//cValue = Bar value collection
//cLabel = Bar label text collection
//------------------------------
	var i, lTemp, lX, lY, obj;
	var frameHeight, lTextHeight;
	var SPACE = 3;

    frameHeight = tickSpaceY * (cTickY.length + 1);
    
    //Draw rect frame
    control.drawRect(x, y, tickSpaceX * (cTickX.length - 1), frameHeight);
                
    //X tick marks
    lY = y + frameHeight;
    prop = vwstring.setKeyValue(prop, "align", "center");
    for (i = 0; i<cTickX.length; i++) {
        lX = x + i * tickSpaceX;
        control.drawLine(lX, lY, lX, lY + SPACE, prop);
        obj = control.drawString(lX, lY, cTickX[i], prop);
    }
    var x2 = lX;
    

    //Y tick marks
    lTextHeight = obj.h;
    lX = x - SPACE;
    prop = vwstring.setKeyValue(prop, "align", "right");
    var prop2 = vwstring.setKeyValue(prop, "objectAlign", "right");
    for (i = 0; i<cTickY.length; i++) {
        lY = y + (i+1) * tickSpaceY - lTextHeight / 2;
        control.drawString(lX, lY, cTickY[i], prop2);
    }
    

    //Draw labels
    var barThickness = lTextHeight*0.6;
    for (i = 0; i<cTickY.length; i++) {
        lY = y + (i+1) * tickSpaceY - lTextHeight / 2;
        lTemp = cValue[i] * 20;
        this.drawBar (control, x, lY, lTemp, barThickness, cLabel[i], prop);
    }
    
	return {x:x,y:y,w:x2-x,h:frameHeight,x2:x2,y2:y+frameHeight};                          
},


//////////////////////////////////////////////////////////////////////////////
drawBar: function(control, x, y, w, h, sText, prop) {

//------------------------------
//control = Control
//x = Bar Left in twips
//y = Bar Top in twips
//w = Bar width in twips
//h = Bar height in twips
//sText = Bar label text
//prop - properties
//------------------------------
                      
    prop = vwstring.setKeyValue(prop, "background", "1");
    control.drawRect(x, y, w, h, prop);

    
    var SPACE = 3;
    prop = vwstring.setKeyValue(prop, "align", "left");
    prop = vwstring.setKeyValue(prop, "background", "0");
    control.drawString(x + w + SPACE, y, sText, prop);
            
}


//////////////////////////////////////////////////////////////////////////////
};
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
